diff --git a/web/.eslintrc.js b/web/.eslintrc.js
index 7abd2c04..56ec061a 100644
--- a/web/.eslintrc.js
+++ b/web/.eslintrc.js
@@ -16,17 +16,14 @@ module.exports = {
   },
   'extends': [
     'eslint:recommended',
-    "plugin:react/recommended",
   ],
   'parserOptions': {
     'ecmaFeatures': {
       'experimentalObjectRestSpread': true,
-      'jsx': true
     },
     'sourceType': 'module'
   },
   'plugins': [
-    'react'
   ],
   'globals': {
     '_': true,
diff --git a/web/karma.conf.js b/web/karma.conf.js
index e8b49254..9ed1be86 100644
--- a/web/karma.conf.js
+++ b/web/karma.conf.js
@@ -28,14 +28,13 @@ module.exports = function (config) {
          * filename: null, // if no value is provided the sourcemap is inlined
          */
         filename: '[name].js.map',
-        test: /\.jsx?$/i, // process .js and .jsx files only
+        test: /\.js$/i, // process .js files only
       }),
     ],
     files: [
       'pgadmin/static/bundle/slickgrid.js',
       {pattern: 'pgadmin/static/**/*.js', included: false, watched: true},
       {pattern: 'pgadmin/browser/static/js/**/*.js', included: false, watched: true},
-      'regression/javascript/**/*.jsx',
       {pattern: 'regression/javascript/**/*.js', watched: true},
     ],
 
@@ -48,9 +47,8 @@ module.exports = function (config) {
     // preprocess matching files before serving them to the browser
     // available preprocessors: https://npmjs.org/browse/keyword/karma-preprocessor
     preprocessors: {
-      'pgadmin/**/js/**/*.js[x]?': ['sourcemap'],
+      'pgadmin/**/js/**/*.js?': ['sourcemap'],
       'regression/javascript/**/*.js': ['webpack', 'sourcemap'],
-      'regression/javascript/**/*.jsx': ['webpack', 'sourcemap'],
       'pgadmin/static/bundle/slickgrid.js': ['webpack', 'sourcemap'],
     },
 
diff --git a/web/pgadmin/static/js/history/history_collection.js b/web/pgadmin/static/js/sqleditor/history/history_collection.js
similarity index 63%
rename from web/pgadmin/static/js/history/history_collection.js
rename to web/pgadmin/static/js/sqleditor/history/history_collection.js
index c066825f..a1654fdc 100644
--- a/web/pgadmin/static/js/history/history_collection.js
+++ b/web/pgadmin/static/js/sqleditor/history/history_collection.js
@@ -10,8 +10,8 @@
 export default class HistoryCollection {
 
   constructor(history_model) {
-    this.historyList = history_model;
-    this.onChange(() => {});
+    this.historyList = _.sortBy(history_model, o=>o.start_time);
+    this.onAdd(() => {});
   }
 
   length() {
@@ -19,8 +19,10 @@ export default class HistoryCollection {
   }
 
   add(object) {
-    this.historyList.push(object);
-    this.onChangeHandler(this.historyList);
+    /* add object in sorted order */
+    let pushAt = _.sortedIndex(this.historyList, object, o=>o.start_time);
+    this.historyList.splice(pushAt, 0, object);
+    this.onAddHandler(object);
   }
 
   reset() {
@@ -28,8 +30,8 @@ export default class HistoryCollection {
     this.onResetHandler(this.historyList);
   }
 
-  onChange(onChangeHandler) {
-    this.onChangeHandler = onChangeHandler;
+  onAdd(onAddHandler) {
+    this.onAddHandler = onAddHandler;
   }
 
   onReset(onResetHandler) {
diff --git a/web/pgadmin/static/js/sqleditor/history/query_history.js b/web/pgadmin/static/js/sqleditor/history/query_history.js
new file mode 100644
index 00000000..b9668f9f
--- /dev/null
+++ b/web/pgadmin/static/js/sqleditor/history/query_history.js
@@ -0,0 +1,81 @@
+import QueryHistoryDetails from './query_history_details';
+import { QueryHistoryEntries } from './query_history_entries';
+import Split from 'split.js';
+import gettext from 'sources/gettext';
+import $ from 'jquery';
+
+export default class QueryHistory {
+  constructor(parentNode, histModel) {
+    this.parentNode = parentNode;
+    this.histCollection = histModel;
+    this.editorPref = {};
+
+    this.histCollection.onAdd(this.onAddEntry.bind(this));
+    this.histCollection.onReset(this.onResetEntries.bind(this));
+  }
+
+  focus() {
+    if (this.queryHistEntries) {
+      this.queryHistEntries.focus();
+    }
+  }
+
+  onAddEntry(entry) {
+    if (this.histCollection.length() == 1) {
+      this.render();
+    } else if (this.queryHistEntries) {
+      this.queryHistEntries.addEntry(entry);
+    }
+  }
+
+  onResetEntries() {
+    this.isRendered = false;
+    this.queryHistEntries = null;
+    this.queryHistDetails = null;
+    this.render();
+  }
+
+  setEditorPref(editorPref) {
+    this.editorPref = editorPref;
+    if(this.queryHistDetails) {
+      this.queryHistDetails.setEditorPref(this.editorPref);
+    }
+  }
+
+  render() {
+    if (this.histCollection.length() == 0) {
+      this.parentNode.empty()
+        .removeClass('d-flex')
+        .append(
+          `<div class='alert alert-info pg-panel-message'>${gettext(
+            'No history found'
+          )}</div>`
+        );
+    } else {
+      this.parentNode.empty().addClass('d-flex');
+      let $histEntries = $('<div><div>').appendTo(this.parentNode);
+      let $histDetails = $('<div><div>').appendTo(this.parentNode);
+
+      Split([$histEntries[0], $histDetails[0]], {
+        gutterSize: 1,
+        cursor: 'ew-resize',
+      });
+
+      this.queryHistDetails = new QueryHistoryDetails($histDetails);
+      this.queryHistDetails.setEditorPref(this.editorPref);
+      this.queryHistDetails.render();
+
+      this.queryHistEntries = new QueryHistoryEntries($histEntries);
+      this.queryHistEntries.onSelectedChange(
+        (entry => {
+          this.queryHistDetails.setEntry(entry);
+        }).bind(this)
+      );
+      this.queryHistEntries.render();
+
+      this.histCollection.historyList.map((entry)=>{
+        this.queryHistEntries.addEntry(entry);
+      });
+    }
+  }
+}
diff --git a/web/pgadmin/static/js/sqleditor/history/query_history_details.js b/web/pgadmin/static/js/sqleditor/history/query_history_details.js
new file mode 100644
index 00000000..03c4a030
--- /dev/null
+++ b/web/pgadmin/static/js/sqleditor/history/query_history_details.js
@@ -0,0 +1,177 @@
+import CodeMirror from 'bundled_codemirror';
+import clipboard from 'sources/selection/clipboard';
+import moment from 'moment';
+import $ from 'jquery';
+
+export default class QueryHistoryDetails {
+  constructor(parentNode) {
+    this.parentNode = parentNode;
+    this.isCopied = false;
+    this.timeout = null;
+    this.isRendered = false;
+    this.sqlFontSize = null;
+
+    this.editorPref = {
+      'sql_font_size': '1em',
+    };
+  }
+
+  setEntry(entry) {
+    this.entry = entry;
+    if (this.isRendered) {
+      this.selectiveRender();
+    } else {
+      this.render();
+    }
+  }
+
+  setEditorPref(editorPref={}) {
+    this.editorPref = {
+      ...this.editorPref,
+      ...editorPref,
+    };
+
+    if(this.query_codemirror) {
+      $(this.query_codemirror.getWrapperElement()).css(
+        'font-size',this.editorPref.sql_font_size
+      );
+
+      this.query_codemirror.refresh();
+    }
+  }
+
+  parseErrorMessage(message) {
+    return message.match(/ERROR:\s*([^\n\r]*)/i)
+      ? message.match(/ERROR:\s*([^\n\r]*)/i)[1]
+      : message;
+  }
+
+  formatDate(date) {
+    return moment(date).format('M-D-YY HH:mm:ss');
+  }
+
+  copyAllHandler() {
+    clipboard.copyTextToClipboard(this.entry.query);
+
+    this.clearPreviousTimeout();
+
+    this.updateCopyButton(true);
+
+    this.timeout = setTimeout(() => {
+      this.updateCopyButton(false);
+    }, 1500);
+  }
+
+  clearPreviousTimeout() {
+    if (this.timeout) {
+      clearTimeout(this.timeout);
+      this.timeout = null;
+    }
+  }
+
+  updateCopyButton(copied) {
+    if (copied) {
+      this.$copyBtn.attr('class', 'was-copied');
+      this.$copyBtn.text('Copied!');
+    } else {
+      this.$copyBtn.attr('class', 'copy-all');
+      this.$copyBtn.text('Copy All');
+    }
+  }
+
+  updateQueryMetaData() {
+    let itemTemplate = (data, description) => {
+      return `<div class='item'>
+                <span class='value'>${data}</span>
+                <span class='description'>${description}</span>
+            </div>`;
+    };
+
+    this.$metaData.empty().append(
+      `<div class='metadata'>
+                ${itemTemplate(this.formatDate(this.entry.start_time), 'Date')}
+                ${itemTemplate(
+                  this.entry.row_affected.toLocaleString(),
+                  'Rows Affected'
+                )}
+                ${itemTemplate(this.entry.total_time, 'Duration')}
+            </div>`
+    );
+  }
+
+  updateMessageContent() {
+    this.$message_content
+      .empty()
+      .append(`<pre class='content-value'>${this.entry.message}</pre>`);
+  }
+
+  updateErrorMessage() {
+    if (!this.entry.status) {
+      this.$errMsgBlock.removeClass('d-none');
+      this.$errMsgBlock.empty().append(
+        `<div class='history-error-text'>
+                    <span>Error Message</span> ${this.parseErrorMessage(
+                      this.entry.message
+                    )}
+                </div>`
+      );
+    } else {
+      this.$errMsgBlock.addClass('d-none');
+      this.$errMsgBlock.empty();
+    }
+  }
+
+  selectiveRender() {
+    this.updateErrorMessage();
+    this.updateCopyButton(false);
+    this.updateQueryMetaData();
+    this.query_codemirror.setValue(this.entry.query);
+    this.updateMessageContent();
+  }
+
+  render() {
+    if (this.entry) {
+      this.parentNode.empty().append(
+        `<div id='query_detail' class='query-detail'>
+            <div class='error-message-block'></div>
+            <div class='metadata-block'></div>
+            <div class='query-statement-block'>
+              <div id='history-detail-query'>
+                <button class='' tabindex=0 accesskey='y'></button>
+                <div></div>
+              </div>
+            </div>
+            <div>
+              <hr class='block-divider'/>
+            </div>
+            <div class='message-block'>
+              <div class='message'>
+                <div class='message-header'>Messages</div>
+                <div class='content'></div>
+              </div>
+            </div>
+        </div>`
+      );
+
+      this.$errMsgBlock = this.parentNode.find('.error-message-block');
+      this.$copyBtn = this.parentNode.find('#history-detail-query button');
+      this.$copyBtn.off('click').on('click', this.copyAllHandler.bind(this));
+      this.$metaData = this.parentNode.find('.metadata-block');
+      this.query_codemirror = CodeMirror(
+        this.parentNode.find('#history-detail-query div')[0],
+        {
+          tabindex: -1,
+          mode: 'text/x-pgsql',
+          readOnly: true,
+        }
+      );
+      $(this.query_codemirror.getWrapperElement()).css(
+        'font-size',this.editorPref.sql_font_size
+      );
+      this.$message_content = this.parentNode.find('.message-block .content');
+
+      this.isRendered = true;
+      this.selectiveRender();
+    }
+  }
+}
diff --git a/web/pgadmin/static/js/sqleditor/history/query_history_entries.js b/web/pgadmin/static/js/sqleditor/history/query_history_entries.js
new file mode 100644
index 00000000..eba2cb0b
--- /dev/null
+++ b/web/pgadmin/static/js/sqleditor/history/query_history_entries.js
@@ -0,0 +1,230 @@
+import moment from 'moment';
+import $ from 'jquery';
+
+const ARROWUP = 38;
+const ARROWDOWN = 40;
+
+export class QueryHistoryEntryDateGroup {
+  constructor(date, groupKey) {
+    this.date = date;
+    this.formatString = 'MMM DD YYYY';
+    this.groupKey = groupKey;
+  }
+
+  getDatePrefix() {
+    let prefix = '';
+    if (this.isDaysBefore(0)) {
+      prefix = 'Today - ';
+    } else if (this.isDaysBefore(1)) {
+      prefix = 'Yesterday - ';
+    }
+    return prefix;
+  }
+
+  getDateFormatted(momentToFormat) {
+    return momentToFormat.format(this.formatString);
+  }
+
+  getDateMoment() {
+    return moment(this.date);
+  }
+
+  isDaysBefore(before) {
+    return (
+      this.getDateFormatted(this.getDateMoment()) ===
+      this.getDateFormatted(moment().subtract(before, 'days'))
+    );
+  }
+
+  render() {
+    return $(`<div class='query-group' data-key='${this.groupKey}'>
+            <div class='date-label'>${this.getDatePrefix()}${this.getDateFormatted(
+      this.getDateMoment()
+    )}</div>
+            <ul class='query-entries'></ul>
+        </div>`);
+  }
+}
+
+export class QueryHistoryItem {
+  constructor(entry) {
+    this.entry = entry;
+    this.$el = null;
+    this.onClickHandler = null;
+  }
+
+  onClick(onClickHandler) {
+    this.onClickHandler = onClickHandler;
+    if (this.$el) {
+      this.$el.off('click').on('click', e => {
+        this.onClickHandler($(e.currentTarget));
+      });
+    }
+  }
+
+  formatDate(date) {
+    return moment(date).format('HH:mm:ss');
+  }
+
+  render() {
+    this.$el = $(
+      `<li class='list-item' tabindex='0' data-key='${this.formatDate(this.entry.start_time)}'>
+          <div class='entry ${this.entry.status ? '' : 'error'}'>
+              <div class='query'>${this.entry.query}</div>
+              <div class='other-info'>
+              <div class='timestamp'>${this.formatDate(this.entry.start_time)}</div>
+              </div>
+          </div>
+      </li>`
+    )
+    .data('entrydata', this.entry)
+    .on('click', e => {
+      this.onClickHandler($(e.currentTarget));
+    });
+  }
+}
+
+export class QueryHistoryEntries {
+  constructor(parentNode) {
+    this.parentNode = parentNode;
+    this.$selectedItem = null;
+    this.groupKeyFormat = 'YYYY MM DD';
+
+    this.$el = null;
+  }
+
+  onSelectedChange(onSelectedChangeHandler) {
+    this.onSelectedChangeHandler = onSelectedChangeHandler;
+  }
+
+  focus() {
+    let self = this;
+
+    if (!this.$selectedItem) {
+      this.setSelectedListItem(this.$el.find('.list-item').first());
+    }
+
+    setTimeout(() => {
+      self.$selectedItem.trigger('click');
+    }, 500);
+  }
+
+  isArrowDown(event) {
+    return (event.keyCode || event.which) === ARROWDOWN;
+  }
+
+  isArrowUp(event) {
+    return (event.keyCode || event.which) === ARROWUP;
+  }
+
+  navigateUpAndDown(event) {
+    let arrowKeys = [ARROWUP, ARROWDOWN];
+    let key = event.keyCode || event.which;
+    if (arrowKeys.indexOf(key) > -1) {
+      event.preventDefault();
+      this.onKeyDownHandler(event);
+      return false;
+    }
+    return true;
+  }
+
+  onKeyDownHandler(event) {
+    if (this.isArrowDown(event)) {
+      if (this.$selectedItem.next().length > 0) {
+        this.setSelectedListItem(this.$selectedItem.next());
+      } else {
+        /* if last, jump to next group */
+        let $group = this.$selectedItem.closest('.query-group');
+        if ($group.next().length > 0) {
+          this.setSelectedListItem(
+            $group.next().find('.list-item').first()
+          );
+        }
+      }
+    } else if (this.isArrowUp(event)) {
+      if (this.$selectedItem.prev().length > 0) {
+        this.setSelectedListItem(this.$selectedItem.prev());
+      } else {
+        /* if first, jump to prev group */
+        let $group = this.$selectedItem.closest('.query-group');
+        if ($group.prev().length > 0) {
+          this.setSelectedListItem(
+            $group.prev().find('.list-item').last()
+          );
+        }
+      }
+    }
+  }
+
+  onSelectListItem(event) {
+    this.setSelectedListItem($(event.currentTarget));
+  }
+
+  dateAsGroupKey(date) {
+    return moment(date).format(this.groupKeyFormat);
+  }
+
+  setSelectedListItem($listItem) {
+    if (this.$selectedItem) {
+      this.$selectedItem.removeClass('selected');
+    }
+    $listItem.addClass('selected');
+    this.$selectedItem = $listItem;
+    this.$selectedItem[0].scrollIntoView(false);
+
+    if (this.onSelectedChangeHandler) {
+      this.onSelectedChangeHandler(this.$selectedItem.data('entrydata'));
+    }
+  }
+
+  addEntry(entry) {
+    /* Add the entry in respective date group in descending sorted order. */
+    let groups = this.$el.find('.query-group');
+    let groupsKeys = $.map(groups, group => {
+      return $(group).attr('data-key');
+    });
+    let entryGroupKey = this.dateAsGroupKey(entry.start_time);
+    let groupIdx = _.indexOf(groupsKeys, entryGroupKey);
+
+    let $groupEl = null;
+    /* if no groups present */
+    if (groups.length == 0) {
+      $groupEl = new QueryHistoryEntryDateGroup(
+        entry.start_time,
+        entryGroupKey
+      ).render();
+      this.$el.prepend($groupEl);
+    } else if (groupIdx < 0 && groups.length != 0) {
+      /* if groups are present, but this is a new group */
+      $groupEl = new QueryHistoryEntryDateGroup(
+        entry.start_time,
+        entryGroupKey
+      ).render();
+      if (groups[groupIdx]) {
+        $groupEl.insertBefore(groups[groupIdx]);
+      } else {
+        this.$el.prepend($groupEl);
+      }
+    } else if (groupIdx >= 0) {
+      /* if groups present, but this is a new one */
+      $groupEl = $(groups[groupIdx]);
+    }
+
+    let newItem = new QueryHistoryItem(entry);
+    newItem.onClick(this.setSelectedListItem.bind(this));
+    newItem.render();
+
+    $groupEl.find('.query-entries').prepend(newItem.$el);
+    this.setSelectedListItem(newItem.$el);
+  }
+
+  render() {
+    let self = this;
+    self.$el = $(`
+            <div id='query_list' class='query-history' tabindex='0'>
+            </div>
+        `).on('keydown', this.navigateUpAndDown.bind(this));
+
+    self.parentNode.empty().append(self.$el);
+  }
+}
diff --git a/web/pgadmin/static/js/sqleditor/query_tool_preferences.js b/web/pgadmin/static/js/sqleditor/query_tool_preferences.js
index 586b0ecd..0d8ac0e7 100644
--- a/web/pgadmin/static/js/sqleditor/query_tool_preferences.js
+++ b/web/pgadmin/static/js/sqleditor/query_tool_preferences.js
@@ -173,7 +173,9 @@ function updateUIPreferences(sqlEditor) {
   sqlEditor.query_tool_obj.refresh();
 
   /* Render history to reflect Font size change */
-  sqlEditor.render_history_grid();
+  sqlEditor.historyComponent.setEditorPref({
+    'sql_font_size' : sql_font_size,
+  });
 }
 
 export {updateUIPreferences};
diff --git a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
index 7d321d65..e7e953dd 100644
--- a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
+++ b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
@@ -25,9 +25,8 @@ define('tools.querytool', [
   'sources/sqleditor/query_tool_http_error_handler',
   'sources/sqleditor/filter_dialog',
   'sources/sqleditor/geometry_viewer',
-  'sources/history/index.js',
-  'sourcesjsx/history/query_history',
-  'react', 'react-dom',
+  'sources/sqleditor/history/history_collection.js',
+  'sources/sqleditor/history/query_history',
   'sources/keyboard_shortcuts',
   'sources/sqleditor/query_tool_actions',
   'sources/sqleditor/query_tool_notifications',
@@ -48,7 +47,7 @@ define('tools.querytool', [
   babelPollyfill, gettext, url_for, $, jqueryui, jqueryui_position, _, S, alertify, pgAdmin, Backbone, codemirror,
   pgExplain, GridSelector, ActiveCellCapture, clipboard, copyData, RangeSelectionHelper, handleQueryOutputKeyboardEvent,
   XCellSelectionModel, setStagedRows, SqlEditorUtils, ExecuteQuery, httpErrorHandler, FilterHandler,
-  GeometryViewer, HistoryBundle, queryHistory, React, ReactDOM,
+  GeometryViewer, historyColl, queryHist,
   keyboardShortcuts, queryToolActions, queryToolNotifications, Datagrid,
   modifyAnimation, calculateQueryRunTime, callRenderAfterPoll, queryToolPref) {
   /* Return back, this has been called more than once */
@@ -60,7 +59,9 @@ define('tools.querytool', [
   var wcDocker = window.wcDocker,
     pgBrowser = pgAdmin.Browser,
     CodeMirror = codemirror.default,
-    Slick = window.Slick;
+    Slick = window.Slick,
+    HistoryCollection = historyColl.default,
+    QueryHistory = queryHist.default;
 
   var is_query_running = false;
 
@@ -1303,25 +1304,17 @@ define('tools.querytool', [
 
       /* Should not reset if function called again */
       if(!self.history_collection) {
-        self.history_collection = new HistoryBundle.HistoryCollection([]);
+        self.history_collection = new HistoryCollection([]);
       }
 
-      var historyComponent;
-      var historyCollectionReactElement = React.createElement(
-        queryHistory.QueryHistory, {
-          historyCollection: self.history_collection,
-          ref: function(component) {
-            historyComponent = component;
-          },
-          sqlEditorPref: {
-            sql_font_size: SqlEditorUtils.calcFontSize(this.preferences.sql_font_size),
-          },
-        });
-      ReactDOM.render(historyCollectionReactElement, $('#history_grid')[0]);
+      if(!self.historyComponent) {
+        self.historyComponent = new QueryHistory($('#history_grid'), self.history_collection);
+        self.historyComponent.render();
+      }
 
       self.history_panel.off(wcDocker.EVENT.VISIBILITY_CHANGED);
       self.history_panel.on(wcDocker.EVENT.VISIBILITY_CHANGED, function() {
-        historyComponent.refocus();
+        self.historyComponent.focus();
       });
     },
 
@@ -2574,6 +2567,12 @@ define('tools.querytool', [
           $('#btn-flash').prop('disabled', false);
           $('#btn-download').prop('disabled', false);
           self.trigger('pgadmin-sqleditor:loading-icon:hide');
+
+          if(!self.total_time) {
+            self.total_time = calculateQueryRunTime.calculateQueryRunTime(
+              self.query_start_time,
+              new Date());
+          }
           self.gridView.history_collection.add({
             'status': status,
             'start_time': self.query_start_time,
diff --git a/web/regression/javascript/history/history_collection_spec.js b/web/regression/javascript/history/history_collection_spec.js
index 592bc867..89995f60 100644
--- a/web/regression/javascript/history/history_collection_spec.js
+++ b/web/regression/javascript/history/history_collection_spec.js
@@ -7,18 +7,17 @@
 //
 //////////////////////////////////////////////////////////////
 
-import HistoryCollection from '../../../pgadmin/static/js/history/history_collection';
-import '../helper/enzyme.helper';
+import HistoryCollection from 'sources/sqleditor/history/history_collection';
 
 describe('historyCollection', function () {
-  let historyCollection, historyModel, onChangeSpy, onResetSpy;
+  let historyCollection, historyModel, onAddSpy, onResetSpy;
   beforeEach(() => {
     historyModel = [{some: 'thing', someOther: ['array element']}];
     historyCollection = new HistoryCollection(historyModel);
-    onChangeSpy = jasmine.createSpy('onChangeHandler');
+    onAddSpy = jasmine.createSpy('onAddHandler');
     onResetSpy = jasmine.createSpy('onResetHandler');
 
-    historyCollection.onChange(onChangeSpy);
+    historyCollection.onAdd(onAddSpy);
     historyCollection.onReset(onResetSpy);
   });
 
@@ -36,12 +35,13 @@ describe('historyCollection', function () {
 
   describe('add', function () {
     let expectedHistory;
+    let newEntry = {some: 'new thing', someOther: ['value1', 'value2']};
     beforeEach(() => {
-      historyCollection.add({some: 'new thing', someOther: ['value1', 'value2']});
+      historyCollection.add(newEntry);
 
       expectedHistory = [
-        {some: 'thing', someOther: ['array element']},
         {some: 'new thing', someOther: ['value1', 'value2']},
+        {some: 'thing', someOther: ['array element']},
       ];
     });
 
@@ -50,7 +50,7 @@ describe('historyCollection', function () {
     });
 
     it('calls the onChange function', function () {
-      expect(onChangeSpy).toHaveBeenCalledWith(expectedHistory);
+      expect(onAddSpy).toHaveBeenCalledWith(newEntry);
     });
   });
 
